!*******************************************************************
!	NEW SUBROUTINE
!*******************************************************************
	subroutine averages(mcstep,mcstepold)
	USE imsl
	USE dflib
      include 'comblock.f'   

      PARAMETER  (K=17,nob=10000,ks=14)
	DIMENSION gsdist(k), R(nob) 
      INTEGER    IOPT, NOUT
      REAL       CLHW, DIV(K), TABLE(K), X(NOB),XLO,XHI,compdat
	REAL	div1(KS),table1(KS),gside(KS)
	character*60 filetemp,filenames
	logical  result2,result1,result3
	DATA DIV/0.2,0.4,0.6,0.8,1.0,1.2,
     &1.4,1.6,1.8,2.0,2.2,2.4,2.6,
     &2.8,3.0,3.2,3.4/
!	Averaging topological output
      write(*,*)
	write(*,*) 'Mcstep', '  Total number of grains'
	open(292,file=filenames(5))
	open(232,file=filenames(16))
	open(235,file=filenames(6))

	do mcs =mcstepold,mcstep
	
	if(mod(mcs,int(compdat(9))).eq.0) then
!	Inititalizing
		do i =1,k
		gsdist(i)=0
		enddo
	perimeternew=0.
		do i =1,ks
		gside(i)=0
		enddo

!********************
		do lname =10,15
		call topology(mcstep,lname,numgr)
!	perimeter calculations
		open(11,file="c:\MC\temp\perim.dat")
		read(11,*)perimeter
		perimeternew=perimeternew+perimeter
		close(11)
!	Grain Size Distribution
		open(53,file="c:\MC\temp\rbyr.dat")
		do kk =1,numgr
		read(53,*)kl,R(kk),X(kk)
		enddo !i=1,numgr
	close(53)
!*********IMSL ROUTINE***************************************

      IOPT = 2
C
	NOBS=numgr
      CALL OWFRQ (NOBS, X, K, IOPT, XLO, XHI, CLHW, DIV, TABLE)
	 do i =1,k
	 GSdist(i)=GSdist(i)+Table(i)
	 enddo !i=1,k
!*************************************************************
	call averagesides(div1,gside,table1,numgr)
		enddo !do lname =10,15

	if(mcstep.eq.1)write(292,*)'Change of average perimeter with time'
	write(292,*)'Perimeter/unit area after iteration 
	1# ',mcstep,'(in mm/sq.mm) =',(perimeternew/6.)
!	output for grain size distribution
!**************************************************
	write(232,*)'Iteration #',mcstep		
	write(232,*)'Range of (D/Davg)   Frequency'
	do i = 1,k
	write(232,*)div(i),gsdist(i)/6.
	enddo
	write(235,*)'****************************'
	write(235,*)'Iteration #',mcstep
	write(235,*)'****************************'
	write(235,*)'Number of sides  Frequency'
	do i = 1,ks
	write(235,*)div1(i),gside(i)/6.
	enddo




!******************************************************
		endif !if(mod..)
	enddo !do mcs
	mcstepold = mcstep + 1

	end subroutine


!*******NEW SUBROUTINE***********************************
	subroutine averagesides(div1,gside,table1,numgr)
	USE imsl
      include 'comblock.f'   

      PARAMETER  (K=14,nob=10000)
	DIMENSION  side(nob) ,gside(k)
      INTEGER    IOPT
	REAL       CLHW, DIV(K), TABLE(K), X(NOB),XLO,XHI,compdat
	REAL	div1(k),table1(k)
	character*60 filetemp,filenames
	DATA DIV/0.0,1.0,2.0,3.0,4.0,5.0,6.0,7.0,8.0,9.0,10.0,11.0,
     &12.0,13.0/

!	Averaging topological output
	div1=div
!********************
		open(21,file="c:\MC\temp\side.dat")
		do kk =1,numgr
		read(21,*)kl,X(kk)
		enddo
	close(21)
!*********IMSL ROUTINE***************************************
      IOPT = 2
C
	NOBS=numgr
      CALL OWFRQ (NOBS, X, K, IOPT, XLO, XHI, CLHW, DIV, TABLE)
	 do i =1,k
	 Gside(i)=Gside(i)+Table(i)
	 enddo
!*************************************************************
	end subroutine
